pkgsrc/mk/plist/libtool-expand
2013-02-23 09:59:14 +00:00

108 lines
3.4 KiB
Bash
Executable file

#! /bin/sh
#
# $NetBSD: libtool-expand,v 1.6 2013/02/23 09:59:14 obache Exp $
#
# Copyright (c) 2004 The NetBSD Foundation, Inc.
# All rights reserved.
#
# This code is derived from software contributed to The NetBSD Foundation
# by Todd Vierling.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
# must display the following acknowledgement:
# This product includes software developed by the NetBSD
# Foundation, Inc. and its contributors.
# 4. Neither the name of The NetBSD Foundation nor the names of its
# contributors may be used to endorse or promote products derived
# from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
: ${ECHO=echo}
: ${GREP=grep}
: ${SORT=sort}
: ${TEST=test}
: ${PWD_CMD="pwd -P"}
: ${BASENAME=basename}
: ${DIRNAME=dirname}
: ${SHLIB_TYPE=none}
self="${0##*/}"
usage() {
${ECHO} 1>&2 "usage: $self archive ..."
}
${TEST} $# -gt 0 || { usage; exit 1; }
for la
do
dir="${la%/*.la}"
library_names=
old_library=
case $dir in
$la) dir= ;;
*) dir="$dir/" ;;
esac
case $la in
/*|./*) lapath="$la" ;;
*) lapath="./$la" ;;
esac
# Skip symlinks to libtool archives -- we only want to expand the
# real libtool archive.
#
${TEST} ! -h "$lapath" || continue
# Skip unreadable *.la files.
if ${TEST} ! -f "$lapath" -o ! -r "$lapath" ; then
${ECHO} 1>&2 "$self: cannot read libtool archive \`$lapath'"
continue
fi
if ${GREP} -q "libtool library file" "$lapath"; then
. "$lapath"
if ${TEST} "$installed" = "no"; then
${ECHO} 1>&2 "$self: \`$lapath' was not properly installed"
exit 1
fi
if ${TEST} ! -z "$dlname" -a ${SHLIB_TYPE} = "PEwin"; then
cwd=`${PWD_CMD}`
libpath="$dir$dlname"
libpath=`${DIRNAME} "$libpath"`
libpath=`cd "$libpath" && ${PWD_CMD}`
libpath="${libpath#${cwd}/}"/`${BASENAME} "${dlname}"`
if ${TEST} ! -f "$libpath"; then
${ECHO} 1>&2 "$self: \`$libpath' was not found"
fi
${ECHO} "$libpath"
fi
for lib in $library_names $old_library; do
libpath="$dir$lib"
if ${TEST} ! -f "$libpath"; then
${ECHO} 1>&2 "$self: \`$libpath' was not found"
fi
${ECHO} "$libpath"
done
fi
done | ${SORT} -u